; "radar"
; ZX Spectrum 256b intro
;
; z80 code - .shahmatist
; bugfix   - .ded
; 05.01.2023, Samara, Russia
; https://emulate.su/rmda/radar.zip
; =RMDA=

; load at	#c000	49152
; launch at	#c02a	49194

		DEVICE	ZXSPECTRUM48

		org #c000
begin:		

bufer:		equ #fd00
newsinus:	equ #9000
sinustab:
	db #94,#32,#32,#22,#22,#10
	db #a4,#32,#32,#22,#22
	db #a4,#43,#23,#22,#20
	db #b4,#43,#32,#32
	db #c4,#43,#43,#20
	db #c6,#44,#33
	db #e5,#54,#40
	db #00,#0f,#75,#50
	db #00,#12,#86
	db #00,#16,#a0
	db #00,#20
start:	

;---SIN table init----------------------------------------------
	ld	hl,newsinus
	ld	sp,hl		;SP init
	ld	de,sinustab-1
	ld	c,1
sin5:	inc	de	
	ld	a,(de)
	rrca
	rrca
	rrca
	rrca
	and	%00001111
	jr	nz,sinff
	inc	de
	ld	a,(de)
	jr	sin4	
sinff:  ld	b,a
sin1:   ld	(hl),c
	inc	hl
	djnz	sin1
	ld	a,(de)
	inc	c
	and	%00001111
	jr	z,sin3
sin4:	ld	b,a
sin2:   ld	(hl),c
	inc	hl
	djnz	sin2
	inc	c
	bit	5,l
	jr	z,sin5
sin3:   push	de
	ex	de,hl
	
	ld	b,e	;ld b,32
	ld	h,d
	ld	l,e

sin6:   dec	l		
	ld	a,23
	sub	(hl)
	ld	(de),a
	inc	e
	djnz	sin6
	ld	l,e
sin7:	dec e		
	ld a,(de)
	ld (hl),a
	inc l
	jr nz,sin7
sin8:	ld c,e	;ld c,128
	ldir
	ld c,(hl)
	inc c
	ex de,hl
	pop de
	ld a,h
	cp (high newsinus)+11
	jr nz,sin5

;-------CLS + BUFFER init--------------------------------------
	ld h,#5b
cls:	dec hl
	ld (hl),b	
	ld a,h
	cp #fc		;buffer init
	jr nz,cls

;--------------------------------------------------------------
	ld	h,#57	;ld hl,#5800
chess:	dec	hl
	ld	a,h
	rra
	sbc	a,a
	xor	%01010101
	ld	(hl),a
	xor	(hl)
	jr	z,chess

;--------------------------------------------------------------
	ld	c,64
	ld	ixh,a	;ld ix,#6000
	ld	d,high newsinus

line2:	ei
	halt

;---keyboard---------------------------------------------------
;	xor	a
	in	a,(#fe)
	or	c	;or %11100000
	inc	a
	jr	nz,line2

;---main loop--------------------------------------------------
	exx
	ld	hl,bufer
	ld	d,#58
pal2:	ld	a,(hl)
        out	(#fe),a	;border VFX and beeper SFX
	and	a
	jr	z,pal1
	dec	a
	ld	(de),a
	ld	(hl),a
pal1:	inc	hl
	inc	de
	ld	a,d
	cp	#5b
	jr	nz,pal2
	exx
	call	lines
	add	a,c
	ld	e,a
	ld	a,ixh
	and 3
	call nz,lines
	ld a,ixh
	and 2
	jr z,lines4
	push de
	ld a,e
	sub 32
	ld e,a
	call lines
	add a,c
	ld e,a
	call lines
	pop de
lines4:	ld	a,e
	sub	c
	ld	e,a

	DUP	5
	inc	ix
	EDUP

	inc	e	
	jr	line2
		
lines:	ld	b,11
	push	de
line1:	ld	a,(de)
	ld	h,c	
	ld	l,a

	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl

	push	de
	ld	a,ixh
	add	a,e
	ld	e,a
	ld	a,(de)
	add	a,l
	ld	l,a
	ld	de,bufer+4
	add	hl,de
	ld	(hl),16
;	ld	(hl),b	;save 1 byte, differet color scheme
	pop	de
	inc	d
	djnz	line1
	pop	de
	ld	a,e
	ret

;--------------------------------------------------------------
fin:		
	display "START  ",/A,start
	display "BEGIN  ",/A,begin
	display "END    ",/A,fin
	display "LENGTH ",/A,fin-begin
	
	SAVESNA		"radar.sna", start
	SAVEBIN		"radar-C000-C02A.bin", begin,fin-begin

	SAVEBIN		"radar", begin,fin-begin
	EMPTYTRD	"radar.trd","radar"
	SAVETRD		"radar.trd","radar.C",begin,fin-begin
;	EMPTYTAP	"radar.tap"
;	SAVETAP		"radar.tap",CODE,"radar",begin,fin-begin
;-------=RMDA=--------------------------------------------[eof]